#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

void print_hostent(struct hostent * hp) {
	char ** ptr;

	printf("Offizieller Host-Name: %s\n", hp->h_name);

	for(ptr = hp->h_aliases; ptr && *ptr; ptr++)
		printf("   Alias: %s\n", *ptr);

	if(hp->h_addrtype == AF_INET)
		for(ptr = hp->h_addr_list; ptr && *ptr; ptr++)
			printf("   Adresse: %s\n",
				inet_ntoa(*((struct in_addr *) *ptr)));
}

int main(int argc, const char **argv) {
	ulong_t addr;
	struct hostent *hp;

	if (argc != 2) {
		fprintf(stderr, "usage: %s IP-address\n", argv[0]);
		exit (1);
	}

	if ((addr = inet_addr(argv[1])) == -1) {
		fprintf(stderr, "IP-Adresse muss die Form a.b.c.d haben\n");
		exit (2);
	}

	hp = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);
	if (hp == NULL) {
		herror("gethostbyaddr()");
		exit (3);
	}

	print_hostent(hp);

	exit (0);
}
